package prefuse.controls;

import java.awt.event.MouseEvent;
import prefuse.visual.EdgeItem;
import prefuse.visual.NodeItem;
import prefuse.visual.VisualItem;



public class EdgeHighlightControl extends ControlAdapter {
	private String activity;
	public EdgeHighlightControl(String activity) {
	        this.activity = activity;
	    }

	/**
     * @see prefuse.controls.Control#itemEntered(prefuse.visual.VisualItem, java.awt.event.MouseEvent)
     */
    public void itemEntered(VisualItem item, MouseEvent e) {
        if ( item instanceof EdgeItem )
            setNeighborHighlight((EdgeItem)item, true);
    }
    
    /**
     * @see prefuse.controls.Control#itemExited(prefuse.visual.VisualItem, java.awt.event.MouseEvent)
     */
    public void itemExited(VisualItem item, MouseEvent e) {
        if ( item instanceof EdgeItem )
            setNeighborHighlight((EdgeItem)item, false);
    }
    
    /**
     * Set the highlighted state of the neighbors of a node.
     * @param n the node under consideration
     * @param state the highlighting state to apply to neighbors
     */
    protected void setNeighborHighlight(EdgeItem e, boolean state) {
       e.setHighlighted(state);
       NodeItem source =  e.getSourceItem();
       source.setHighlighted(state);
       NodeItem dest =  e.getTargetItem();
       dest.setHighlighted(state);
       
       if (activity != null){
    	   e.getVisualization().run(activity);
       }
       
       
     }
}
