package prefuse.controls;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.MouseEvent;
import java.awt.event.MouseWheelEvent;

import javax.swing.Timer;

import prefuse.Display;
import prefuse.visual.VisualItem;

public class IdleHighQualityRenderer implements Control {

	private boolean highQuality = false;
	private boolean fullIdle = true;
	private Display d;
	public IdleHighQualityRenderer(final Display d) {
		this.d = d;
		Timer t = new Timer(500, new ActionListener(){

			public void actionPerformed(ActionEvent e) {
				if (fullIdle){
					if (!d.isTranformInProgress()){
						if (!highQuality) {
							highQuality = true;
							d.setHighQuality(true);
							d.repaint();
						}
					}
				}else{
					fullIdle = true;
				}
			}
		
		});
		t.start();
		
	}
	public boolean isEnabled() {		
		return true;
	}
	public void setEnabled(boolean enabled) {
		
	}
	public void itemDragged(VisualItem item, MouseEvent e) {
		
		userInteractionDetected();
	}
	public void itemMoved(VisualItem item, MouseEvent e) {
		
		userInteractionDetected();		
	}
	public void itemWheelMoved(VisualItem item, MouseWheelEvent e) {
		
		userInteractionDetected();	
	}
	public void itemClicked(VisualItem item, MouseEvent e) {
		
		userInteractionDetected();	
	}
	public void itemPressed(VisualItem item, MouseEvent e) {
		
		userInteractionDetected();	
	}
	public void itemReleased(VisualItem item, MouseEvent e) {
		
		userInteractionDetected();	
	}
	public void itemEntered(VisualItem item, MouseEvent e) {
		
		userInteractionDetected();	
	}
	public void itemExited(VisualItem item, MouseEvent e) {
		
		userInteractionDetected();	
	}
	public void itemKeyPressed(VisualItem item, KeyEvent e) {
		
		userInteractionDetected();		
	}
	public void itemKeyReleased(VisualItem item, KeyEvent e) {
		
		userInteractionDetected();		
	}
	public void itemKeyTyped(VisualItem item, KeyEvent e) {
		
		userInteractionDetected();		
	}
	public void mouseEntered(MouseEvent e) {
		
		userInteractionDetected();	
	}
	public void mouseExited(MouseEvent e) {
		
		userInteractionDetected();	
	}
	public void mousePressed(MouseEvent e) {
		
		userInteractionDetected();	
	}
	public void mouseReleased(MouseEvent e) {
		
		userInteractionDetected();	
	}
	public void mouseClicked(MouseEvent e) {
		
		userInteractionDetected();	
	}
	public void mouseDragged(MouseEvent e) {
		
		userInteractionDetected();		
	}
	public void mouseMoved(MouseEvent e) {
		
		userInteractionDetected();	
	}
	public void mouseWheelMoved(MouseWheelEvent e) {
		
		userInteractionDetected();	
	}
	public void keyPressed(KeyEvent e) {
		
		userInteractionDetected();	
	}
	public void keyReleased(KeyEvent e) {
		
		userInteractionDetected();	
	}
	
	public void keyTyped(KeyEvent e) {
		
		userInteractionDetected();	
	}
	
	private void userInteractionDetected() {
		fullIdle = false;
		if (d.getScale() < 0.7f){
			highQuality = false;			
			d.setHighQuality(false);
		}
		d.requestFocusInWindow();
	}
	
}
