package prefuse.render;

import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.Shape;
import java.awt.geom.Line2D;
import java.awt.geom.Point2D;
import java.awt.geom.Rectangle2D;
import java.util.List;

import prefuse.util.GraphicsLib;
import prefuse.visual.EdgeItem;
import prefuse.visual.VisualItem;
import cytoPrefuse.CytoPrefuse;
import cytoPrefuse.EdgeBundler;

public class BundleEdgeRenderer extends AbstractShapeRenderer {
	  protected Line2D       line  = new Line2D.Float();	
	  protected Rectangle2D cursorRect = new Rectangle2D.Float();
	 
	  
	 public BundleEdgeRenderer() {
	 }


	 public boolean locatePoint(Point2D p, VisualItem item) {
     	cursorRect.setFrame(p.getX(), p.getY(), 2,2);
     	return EdgeBundler.edgeIntersectsRect(item, cursorRect);
     }

	 public void setBounds(VisualItem item) {
	    Shape shape = getShape(item);
	    if (shape != null)
	    	GraphicsLib.setBounds(item, shape, getStroke(item));
	 }
	 protected Shape getRawShape(VisualItem item) {
		 return (Shape) item.get(CytoPrefuse.EDGE_SPLINE);	
	 }


	public void render(Graphics2D g, VisualItem item) {
		 EdgeItem edge = (EdgeItem) item;
		 if (edge.getSourceItem().isVisible() && edge.getTargetItem().isVisible()){
			 super.render(g, item);
         }     
	}
    public void renderEnds (Graphics2D g, VisualItem item){
     EdgeItem edge = (EdgeItem) item;
     if (edge.getSourceItem().isVisible() && edge.getTargetItem().isVisible()){
         List controlPoints = (List)edge.get(CytoPrefuse.SPLINE_BETA_ADJUSTED);
         if (controlPoints.size() >=2) {
             Point2D start = (Point2D) controlPoints.get(0);
             g.setColor(Color.black);
             g.fillOval((int)start.getX()-3, (int)start.getY()-3,6,6);
             Point2D end = (Point2D) controlPoints.get(controlPoints.size()-1);
             g.fillOval((int)end.getX()-3, (int)end.getY()-3,6,6);
         } 
     }     
 
    }
}
